// The Guillotine!
// by ptdw
//
// v1.2
//
// COPYRIGHT:
// This script, from http://ss.deviatenow.com, is protected by this licence:
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/
// This copyright refers only to this script itself; it does not include any other included resources
// (images, music, sounds, etc.) which remain the property of their owners.
//
// Change Log
// 1.1 Added female victim
// 1.2 Added random malfunction option

setInfos(6, "The Guillotine", "A virtual guillotine for e-stim play.","ptdw", "v1.2", 0x222222, "en", ["pain", "cbt", "estim", "formale", "forfemale"]);

// Debug-sensitive variables
def identifier = loadInteger("intro.launch.firsttime")
def playerName = loadString("intro.name")
def femalePlayer = loadBoolean("intro.female")
def reset = false

// Set default non-volative variables
if(loadBoolean("stripordie.audio_estim")==null || reset)
    save("stripordie.audio_estim",true)
if(loadString("stripordie.estim_start")==null || reset)
    save("stripordie.estim_start","usbcontrol.exe start")
if(loadString("stripordie.estim_finish")==null || reset)
    save("stripordie.estim_finish","usbcontrol.exe stop")
if(loadInteger("guillotine.min_time")==null || reset)
    save("guillotine.min_time",30)
if(loadInteger("guillotine.max_time")==null || reset)
    save("guillotine.max_time",60)
if(loadInteger("guillotine.malf_chance")==null || reset)
    save("guillotine.malf_chance",1)
if(loadInteger("guillotine.bind_time")==null || reset)
    save("guillotine.bind_time",60)
if(loadInteger("guillotine.retry")==null || reset)
    save("guillotine.retry",0)
if(loadBoolean("guillotine.surprise")==null || reset)
    save("guillotine.surprise",false)

// Read non-volatile variables
def audio_estim = loadBoolean("stripordie.audio_estim")
def estim_start = loadString("stripordie.estim_start")
def estim_finish = loadString("stripordie.estim_finish")
def minTime = loadInteger("guillotine.min_time")
def maxTime = loadInteger("guillotine.max_time")
def malfChance = loadInteger("guillotine.malf_chance")
def bindTime = loadInteger("guillotine.bind_time")
def retry = loadInteger("guillotine.retry")
def surprise = loadBoolean("guillotine.surprise")

// Regular variables
def delayTime = 0
def intTime = 0

//Rules explaination
def rulesDisplay = {
    show("This script is a virtual guillotine, and is fully configurable. "
	+"\n\nYou will connect a computer-controlled torture device (such as e-stim) to your genitals. Then, you'll bind yourself so that you cannot escape quickly. "
	+"\n\nYou may even want to use an external self-bondage app to ensure you remain bound for a certain duration."
	+"\n\nAfter your genitals are connected and you are bound, the blade will slowly start to rise, in accordance with the min and max times you have set.")
    showButton("What happens when the blade reaches the top?")
    show("Glad you asked! After the blade is fully raised, it will come slamming back down, with your helpless genitals directly in its path!"
	+"\n\nHowever, there is a chance that the guillotine will malfunction. If it malfunctions, the guards may repair it, but that's up to you.")
    showButton("And if it doesn't malfunction?")
    show("Once the blade reaches your genitals, the torture device will trigger!"
	+"\n\nSince you can set your own odds, it's best to play with your torture device set to a level of pain higher than normal. That will ensure you "
    +"are properly dreading the moment the blade falls! ")
    showButton("Is there any other way to escape the blade?")
    show("In theory, you could bind yourself in a manner that allows you to escape, but requires sufficient time.\n\nThen, set the guillotine to trigger "
	+"in a similar amount of time, forcing you to race the clock.")
    showButton("Okay...")
    show("Regardless of how you choose to play, your genitals will be in great peril of extreme pain.\n\nLet's hope lady luck is watching over you... ")
    showButton("*gulp*")
}

def Rules = {
    rulesDisplay()
    while(getBoolean("Do you need to go back over the rules again?","Yes","I understand them"))
    {
        rulesDisplay()
    }
}

def Setup = {
    def stimOk = false

	// Basic setup of time and probability of failure
    setImage("guillotine/stopwatch.png")
	def valid = false
	while (!valid) {
		minTime = getInteger("Set the minimum time before the blade falls (in seconds) [10+]:", minTime)
		if (minTime >= 10) valid = true 
	}
	valid = false
	while (!valid) {
		maxTime = getInteger("Set the maximum time before the blade falls (in seconds) [>"+minTime+"]:", maxTime)
		if (maxTime >= minTime) valid = true
	}
	valid = false
	while (!valid) {
		bindTime = getInteger("How much time do you need to bind yourself before starting the guillotine sequence (in seconds):", bindTime)
		if (bindTime >= 0) valid = true
	}
    setImage("guillotine/gears.png")
	if (getBoolean("Would you like to set the odds of malfunction?  Or should I surprise you once you're tied up and it's too late to back out?",
	"I'll set the odds","Surprise me")) {
		valid = false
		while (!valid) {
			malfChance = getInteger("Set the chance that the guillotine will malfunction [0-10]:", malfChance)
			if ((malfChance >= 0) && (malfChance <= 10)) valid = true
		}
		surprise = false
	} else {
		surprise = true
	}
	valid = false
	while (!valid) {
		retry = getInteger("If the guillotine malfunctions, how many times should the guards try to fix it?:", retry)
		if (retry >= 0) valid = true
	}

    save("guillotine.min_time",minTime)
    save("guillotine.max_time",maxTime)
    save("guillotine.bind_time",bindTime)
    save("guillotine.malf_chance",malfChance)
    save("guillotine.retry",retry)
    save("guillotine.surprise",surprise)

    // Customize punishment
    setImage("guillotine/pain.png")
    def menu = getSelectedValue("For the most realistic experience, I need a method of automatically inflicting "
    +"your genitals with severe pain when the blade falls."
    +"\n\nBy default, the game uses an audio-based e-stim device, which is connected to your computer's headphone port. "
    +"\n\nHowever, you can also choose to use any sort of external device, which is controlled by a start and stop command "
    +"run by your computer when the blade falls."
    +"\n\nHow will pain be inflicted?", ["External Device","Audio E-stim"])

    // Audio e-stim
    setImage("stripordie/abox.png")
    if(menu==1) {
        audio_estim = true
        while (!stimOk) {
            if (getBoolean("If you want to get a small taste of what it will feel like when the blade falls, press the \"TEST\" button "
                +"to feel a short sample at half the intensity."
                +"\n\nIf you think this is painful, just wait until the blade cuts for real!","TEST","Continue")) {

                playBackgroundSound("guillotine/guilcal.wav")
                wait(1)

            } else stimOk = true
        }
    }

    // External device
    else if(menu==0) {
        audio_estim = false

        // Test and setup the external device
        def extOk = false
        while (!extOk) {

            // Define the external commands used to control the device
            setImage("stripordie/2b.png")
            estim_start = getString("Let's make sure your computer is linked to your device with the correct commands."
            +"\n\nWhat is the command your computer runs to start your device:",estim_start)
            estim_finish = getString("What is the command your computer runs to stop your device:",estim_finish)

            // Test
            stimOk = false
            while (!stimOk) {
                if (getBoolean("It is best to have a quick test first! Turn the output down to half and press the \"TEST\" button "
                    +"to feel a short sample - remember to put the output back up to full after."
                    +"\n\nIf you think this is painful, just wait until the blade falls!","TEST","Continue")) {

                    useFile(estim_start)
                    wait(2)
                    useFile(estim_finish)
                    wait(1)

                    if (getBoolean("Did the device work correctly?","Yes","No")) {
                        stimOk = true
                        extOk = true
                    } else stimOk = true
                } else {
                    stimOk = true
                    extOk = true
                }
            }
        }
    }

    save("stripordie.audio_estim",audio_estim)
    save("stripordie.estim_start",estim_start)
    save("stripordie.estim_finish",estim_finish)
}

// Tease the player as the guillotine is lifting
def taunt = {
	def tauntText = ["Your poor cock is so helpless!",
    "The higher the blade raises, the closer it is to slamming down!",
    "You must be sweating bullets now...",
    "If you're religious, you should start praying!",
    "The pain will be intense, but thankfully the blade is swift!",
    "Look at that sharp heavy blade hovering over your helpless cock!",
    "Do you think you can escape? Maybe it will malfunction...",
    "Only time is separating the edge of the blade from your cock!"]

	if (femalePlayer) {
		tauntText = ["Your poor body is so helpless!",
    		"The higher the blade raises, the closer it is to slamming down!",
    		"You must be sweating bullets now...",
    		"If you're religious, you should start praying!",
    		"The pain will be intense, but thankfully the blade is swift!",
    		"Look at that sharp heavy blade hovering over your helpless pussy!",
    		"Do you think you can escape? Maybe it will malfunction...",
    		"Only time is separating the edge of the blade from your pussy!"]
	}
	show(tauntText[getRandom(8)])
}

if (femalePlayer)
	setImage("guillotine/guillotine1f.png")
else
	setImage("guillotine/guillotine1.png")

// Intro
def initial_setup = true
def quit = false
while(initial_setup)
{
    setImage("guillotine/guillotine.jpg")
	def text = "Hi, "+playerName+"! Welcome to \"The Guillotine\"!"
    text +="\n\nYou have been sentenced to virtual castration, and will submit your cock to the cruel blade of the guillotine!"
	text +="\n\nWould you like to read the instructions before we begin?"
	if (femalePlayer) {
		text = "Hi, "+playerName+"! Welcome to \"The Guillotine\"!"
    		text +="\n\nYou have been sentenced to virtual torture, and will submit your pussy to the cruel blade of the guillotine!"
		text +="\n\nWould you like to read the instructions before we begin?"
	}
    def menu = getSelectedValue(text, ["Instructions","Setup","Play"])
    if(menu==1) Setup()
    else if(menu==0) Rules()
    else initial_setup = false
}

if (femalePlayer) {
	setImage("guillotine/guillotine1f.png")
	show("It's time to begin your torture.\n\nStrip naked now!")
	showButton("Naked")
	show("This is likely the last time you'll be able to get wet.\n\nMassage your pussy until it's wet and swollen--but no more!")
	setImage("guillotine/guillotine2f.png")
	showButton("Wet")
	show("Prisoner! kneel in front of the guillotine with your swollen pussy exposed."
	+"\n\n(Attach the electrodes/torture device now)")
	showButton("OK")
	setImage("guillotine/guillotine3f.png")
	show("Lay down on the guillotine platform!"
	+"\n\n(Power on your device and turn up the volume)")
	showButton("OK")

} else {
	setImage("guillotine/guillotine1.png")
	show("It's time to begin your castration.\n\nStrip naked now!")
	showButton("Naked")
	show("This is likely the last time you'll be able to get hard.\n\nMassage your cock until it's stiff enough to fit through the hole in the guillotine--but no more!")
	showButton("Hard")
	setImage("guillotine/guillotine2.png")
	show("Prisoner! kneel in front of the guillotine with your swollen cock exposed."
	+"\n\n(Attach the electrodes/torture device now)")
	showButton("OK")
	setImage("guillotine/guillotine3.png")
	show("Insert your cock into the guillotine!"
	+"\n\n(Power on your device and turn up the volume)")
	showButton("OK")
}

show("This is your last chance to back out. Are you sure you are ready for this?")
showButton("I'm Ready")
show("Guards, bind the prisoner!"
+"\n\n(Attach restraints so that you cannot escape quickly)")
wait(4)

// Wait for the player to be bound
def bindCount = bindTime
while (bindCount >= 0) {
	wait(1)
	show("Time remaining to securely bind yourself: \n\n"+"-- "+bindCount+" --")
	bindCount--
}
wait(1)

// Reveal the surprise
if (surprise) {
	malfChance = getRandom(9) + 1
	show("Aww, you're so helpless like that! I bet you're hoping for a malfunction! Well...")
	wait(10)
	if (malfChance < 5) show("Sorry to tell you, but your chances aren't looking good!")
	else show("You may get lucky this time...")
	wait(10)
	show("The chances of malfunction are "+malfChance+" in 10!")
	wait(10)
}

// Main loop
while (!quit) {
	def success = false
	def chop = false

	// Calculate the timing
	delayTime = getRandom(maxTime - minTime) + minTime

	show(null)
	intTime = (delayTime/10)

	// Raise the guillotine
	show("Guards, raise the blade!")
	wait(3)

	def teaseTime = 0
	def x = 3
	def tease = 0
	(3..12).each {
		if (femalePlayer)
			setImage("guillotine/guillotine" + x + "f.png")
		else
			setImage("guillotine/guillotine" + x + ".png")

		// Randomly tease every 5 seconds or so
		if (x == 12) {
			show("Blade in position!")
		} else {
			def currTime = getTime()
			if ((currTime - teaseTime>=10) && (tease == 0)) {
				taunt()
				teaseTime = currTime
			}
		}
		tease = getRandom(2)
		wait(intTime)
		x++
	}

	// Hesitate
	wait(getRandom(5))

	// Decide whether or not to chop
	if ((getRandom(10)+1) > malfChance) chop = true

	// Drop the guillotine
	x = 12
	show("Swhoosh!")
	
	// Trigger audio a bit early
	if (chop && audio_estim) {
    		playBackgroundSound("guillotine/guilfall.wav")
	}

	// Show the falling blade
	(12..3).each {
		if (femalePlayer)
			setImage("guillotine/guillotine" + x + "f.png")
		else
			setImage("guillotine/guillotine" + x + ".png")

		wait(0.01)
		x--
	}

	// Chop
	def result = null
	if (chop) {
		if (femalePlayer) {
			show("***SWOOSH***")
			setImage("guillotine/guillotine13f.png")
		} else {
			show("***WHACK***")
			setImage("guillotine/guillotine13.png")
		}

        	if (!audio_estim)
			useFile(estim_start)
		wait(5)
        if (!audio_estim) {
        		useFile(estim_finish)
		}
		success = true
		if (femalePlayer) 
			show("Torture successful!")
		else 
			show("Castration successful!")
		wait(5)

		result = "That must have hurt!"

	// Malfunction
	} else {
		result = "You were spared!"
	}
	
	//Again?
	if (!success && (retry > 1)) {
		retry--
		show("Damn! It malfunctioned. Guards, repair the guillotine at once!")
		wait(5)
	} else if (!getBoolean(result+"\n\nWould you like to try again?", "Yes", "No")) {
		quit = true
	} else {
		retry = loadInteger("guillotine.retry")
	}
}

// This script, from http://ss.deviatenow.com, is protected by this licence :
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/

/*
 * Resources
 * scripts/guillotine.groovy
 * images/guillotine/*
 * images/stripordie/abox.png
 * images/stripordie/2b.png
 * sounds/guillotine/*
*/

















